const wwt = parseInt($(window).width());
const wht = parseInt($(window).height());

$(function ($) {
    $.fn.panel = function (options) {
        var panel = {
            id: options.id || Math.floor((Math.random() * 10000000)),
            title: options.title || "",
            speed: options.speed || 0.25,
            drag: function ($ontab, $drag) {
                dragResizeAction($ontab, $drag, 'd', control.resize, control.onResize, control.onDrag);
            },
            minimize: function ($panel) {
                if ($panel.attr("data-minimize") === "1") {
                    minimizePanelOut($panel, panel.speed, control.resize, control.onResize, control.onDrag);

                } else {

                    minimizePanelIn($panel, panel.speed);
                    setTimeout(function () {
                        $panel.find(".ontab-header").off("mousedown").on("click", function () {
                            panel.minimize($panel);
                        });
                    }, panel.speed * 1000);
                }
            },
            maximize: function ($panel) {
                if ($panel.attr("data-maximize") === "1") maximizePanelOut($panel, panel.speed, control.resize, control.onResize, control.onDrag);
                else maximizePanelIn($panel, panel.speed, control.resize);
                panelScrool();
            },
            close: function ($panel) {
                closePanel($panel);
            }
        };

        var css = {
            "top": parseInt(wht * (wwt < 900 ? (wwt < 500 ? 0 : 0.025) : 0.05)),
            "left": parseInt(wwt * (wwt < 900 ? (wwt < 500 ? 0 : 0.05) : 0.1)),
            "width": parseInt(wwt * (wwt < 900 ? (wwt < 500 ? 1 : 0.9) : 0.8)),
            "height": parseInt(wht * (wwt < 900 ? (wwt < 500 ? 1 : 0.95) : 0.9)),
            "z-index": 1,
            "transition-duration": panel.speed * 1.3 + "s",
            "border-radius": 0,
            "min-width": 190,
            "max-width": wwt,
            "min-height": 30,
            "max-height": wht
        };
        $.extend(css, options.css);

        var control = {
            drag: true,
            resize: true,
            minimize: true,
            maximize: true,
            close: true,
            onClose: false,
            onMinimize: false,
            onMaximize: false,
            onDrag: false,
            onResize: false
        };
        $.extend(control, options.control);

        var attr = {
            "data-drag": control.drag === true ? 1 : 0,
            "data-top": css.top,
            "data-left": css.left,
            "data-width": css.width,
            "data-height": css.height
        };
        if (control.minimize) attr['data-minimize'] = 0;
        if (control.maximize) attr['data-maximize'] = 0;
        $.extend(attr, options.attr);

        var body = {
            html: '',
            css: {
                padding: 0,
                height: parseInt(css.height) - 45
            }
        };
        body = $.extend(true, {}, body, options.body);

        /**
         * TAB CREATE AND FUNCTIONS
         * */

        var $ontab = $("<div />").attr({'class': 'ontab', 'id': panel.id}).appendTo("body");

        $ontab.attr(attr).css({
            "left": options.target ? parseInt(options.target.offset().left) + parseInt(options.target.width()*0.5) : wwt * 0.5,
            "top": options.target ? parseInt(options.target.offset().top - $(window).scrollTop()) + parseInt(options.target.height()*0.5) : wht * 0.5
        });
        setTimeout(function () {
            $ontab.css(css);
        }, 1);

        var $drag = $("<div />").addClass("ontab-header").prependTo($ontab);
        $("<div />").addClass("title").text(panel.title).prependTo($drag);
        $("<div />").addClass("ontab-content").css(body.css).html(body.html).prependTo($ontab);

        if (control.minimize) {
            var $mini = $("<div />").addClass("ontab-button btn-ontab-mini").attr("title", "minimizar").text("-").prependTo($drag);
            $mini.on("click", function () {
                if (control.onMinimize) {
                    if (!control.onMinimize()) {
                        panel.minimize($ontab);
                    }
                } else {
                    panel.minimize($ontab);
                }
            });
        }
        if (control.maximize) {
            var $maxi = $("<div />").addClass("ontab-button btn-ontab-maxi").attr("title", "maximizar").html("<div class='maxi'></div>").prependTo($drag);
            $drag.on('dblclick', function () {
                panel.maximize($ontab);
            });
            $maxi.on("click", function () {
                if (control.onMaximize) {
                    if (!control.onMaximize()) {
                        panel.maximize($ontab);
                    }
                } else {
                    panel.maximize($ontab);
                }
            });
        }
        if (control.close) {
            var $close = $("<div />").addClass("ontab-button btn-ontab-close").attr("title", "fechar").text("x").prependTo($drag);
            $close.on("click", function () {
                if (control.onClose) {
                    if (!control.onClose()) {
                        panel.close($ontab);
                    }
                } else {
                    panel.close($ontab);
                }
            });
        }
        if (control.drag) {
            panel.drag($ontab, $drag);
        }
        if (control.resize) {
            var $resize = $("<div />").addClass("jResize").appendTo($ontab);
            resize($ontab, $resize, control.resize, control.onResize, control.onDrag);
        }

        $ontab.css("z-index", getLastIndex($ontab)).on("mousedown", function () {
            $(this).css("z-index", getLastIndex($(this)));
        });

        $("html").scrollBlock();
    };

    $.fn.scrollBlock = function (enable) {
        if (typeof(enable) === "undefined" || enable) {
            window.oldScrollPos = $(window).scrollTop();

            $(window).on('scroll.scrolldisabler', function (event) {
                $(window).scrollTop(window.oldScrollPos);
                event.preventDefault();
            });
        } else {
            $(window).off('scroll.scrolldisabler');
        }
    };
}(jQuery));

    function closePanel($panel) {
        if ($panel.attr("data-minimize") === "1") {
            $panel.attr("data-minimize", 0);
            reazusteMinimalize();
        }
        $panel.remove();
        panelScrool();
    }

    function stop (event, M) {
        $(document).off('mousemove mouseup');
        return dragResizeModule(event, M);
    }

    function dragResizeAction ($ontab, $resize, key, haveResize, onResize, onDrag) {
        $resize.on('mousedown', {e: $ontab, k: key}, function (v) {
            $ontab.css({"transition-duration": "0s", "z-index": getLastIndex($ontab)});
            var changeState = 0;
            var mii = {'x': event.pageX, 'y': event.pageY};
            var d = v.data, p = {};
            var windowsTab = d.e;
            if (windowsTab.css('position') !== 'relative') {
                try {
                    windowsTab.position(p);
                } catch (e) {
                }
            }
            var M = {
                h: $resize,
                X: p.left || getInt(windowsTab, 'left') || 0,
                Y: p.top || getInt(windowsTab, 'top') || 0,
                W: getInt(windowsTab, 'width') || windowsTab[0].scrollWidth || 0,
                H: getInt(windowsTab, 'height') || windowsTab[0].scrollHeight || 0,
                pX: v.pageX,
                pY: v.pageY,
                k: d.k,
                o: windowsTab
            };

            $(document).mousemove(function (event) {
                if (changeState < 1) {
                    if (event.pageX > mii.x + 12 || event.pageX < mii.x - 12 || event.pageY > mii.y + 12 || event.pageY < mii.y - 12) {
                        changeState = 1;
                    }
                }

                if ($ontab.attr("data-maximize") === "1" && changeState === 1) {
                    $ontab.attr("data-maximize", 0).css({
                        'transition-duration': '0s',
                        'width': parseInt($ontab.attr("data-width")) + 'px',
                        'height': parseInt($ontab.attr("data-height")) + 'px'
                    }).find(".ontab-content").css("height", parseInt($ontab.attr("data-height")) - 45 + 'px');

                    if (haveResize) resize($ontab, $ontab.find(".jResize").css("cursor", "se-resize"), haveResize, onResize, onDrag);
                }

                var newPosition = dragResizeModule(event, M);
                windowsTab.css(newPosition);
                if (M.k === "r") {
                    windowsTab.find(".ontab-content").css({height: newPosition.height - 45});
                }

            }).mouseup(function (event) {
                if (changeState === 1) {
                    var newPosition = stop(event, M);
                    windowsTab.css(newPosition);
                    if (M.k === "r") {
                        windowsTab.find(".ontab-content").css({height: newPosition.height - 45});
                        if (onResize) onResize();
                    } else {
                        if (onDrag) onDrag();
                    }
                    changeState = 0;
                } else {
                    stop(event, M);
                    if ($ontab.attr("data-maximize") === "1") {
                        $ontab.css({
                            'top': -1 + 'px',
                            'left': 0
                        });
                    }
                }
            });

            return false;
        });
    }

    function resize ($ontab, $resize, resize, onResize, onDrag) {
        dragResizeAction($ontab, $resize, 'r', resize, onResize, onDrag);
    }

    function minimizePanelOut($panel, speed, resize, onResize, onDrag) {

        $panel.find(".ontab-header").off("click");
        $panel.attr("data-minimize", 0);

        if ($panel.attr("data-maximize") === "1") {
            maximizePanelIn($panel, resize);

        } else {
            $panel.css({
                "top": parseInt($panel.attr("data-top")) + "px",
                "left": parseInt($panel.attr("data-left")) + "px",
                "width": parseInt($panel.attr("data-width")) + "px",
                "height": parseInt($panel.attr("data-height")) + "px"
            });
            panelScrool();
        }

        if ($panel.attr("data-drag") === "1") dragResizeAction($panel, $panel.find(".ontab-header"), 'd', resize, onResize, onDrag);

        reazusteMinimalize();

        setTimeout(function () {
            $panel.css("transition-duration", "0s");
        }, speed * 1000);
    }

    function minimizePanelIn($panel, speed) {
        if ($panel.attr("data-maximize") === "0") storePosition($panel);

        var left = 0;
        $(".ontab").each(function () {
            if ($(this).attr("data-minimize") === "1") {
                left += parseInt($(this).css("min-width"));
            }
        });

        $panel.attr("data-minimize", 1).css({
            "transition-duration": speed + "s",
            "top": wht - 30 + "px",
            "left": left,
            "width": 0,
            "height": 0
        });

        panelScrool();
    }

    function maximizePanelOut($panel, speed, haveResize, onResize, onDrag) {
        $panel.attr("data-maximize", 0).css({
            "transition-duration": speed + "s",
            'width': parseInt($panel.attr("data-width")) + 'px',
            'height': parseInt($panel.attr("data-height")) + 'px',
            'top': parseInt($panel.attr("data-top")) + 'px',
            'left': parseInt($panel.attr("data-left")) + 'px'
        }).find(".ontab-content").css("height", parseInt($panel.attr("data-height")) - 45 + 'px');

        setTimeout(function () {
            $panel.css("transition-duration", "0s");
        }, speed * 1000);

        if (haveResize) resize($panel, $panel.find(".jResize").css("cursor", "se-resize"), haveResize, onResize, onDrag);
    }

    function maximizePanelIn($panel, speed, resize) {
        if ($panel.attr("data-minimize") === "1") {
            storePosition($panel);
        }

        $panel.attr("data-maximize", 1).css({
            "transition-duration": speed + "s",
            'width': '100%',
            'height': '100%',
            'top': '-1px',
            'left': '0'
        }).find(".ontab-content").css("height", wht - 45 + "px");

        if(resize) $panel.find(".jResize").off("mousedown").css("cursor", "initial");
    }

    function dragResizeModule (v, M) {
        if (M.k === 'd') {
            var left = M.X + v.pageX - M.pX;
            var top = M.Y + v.pageY - M.pY;
            left = left < 0 ? 0 : left;
            top = top < -1 ? -1 : top;

            if ((left !== 0 || top > -1) && M.o.attr("data-maximize") === '0') {
                M.o.attr("data-left", left);
                M.o.attr("data-top", top);
            }

            return {left: left, top: top};
        } else {
            var width = Math.max(v.pageX - M.pX + M.W, 0);
            var height = Math.max(v.pageY - M.pY + M.H, 0);

            M.o.attr("data-width", (wwt < parseInt(M.o.attr("data-left")) + width ? wwt - parseInt(M.o.attr("data-left")) : width));
            M.o.attr("data-height", (wht < (parseInt(M.o.attr("data-top")) + height + 3) ? wht - parseInt(M.o.attr("data-top")) - 3 : height));

            return {width: M.o.attr("data-width"), height: M.o.attr("data-height")};
        }
    }

    function storePosition ($panel) {
        $panel.attr({
            "data-width": 2 + parseInt($panel.width() + parseInt($panel.css("padding-left")) + parseInt($panel.css("padding-right"))),
            "data-height": 2 + parseInt($panel.height() + parseInt($panel.css("padding-top")) + parseInt($panel.css("padding-bottom"))),
            "data-top": $panel.offset().top - $(window).scrollTop(),
            "data-left": $panel.offset().left
        });
    }

    function panelScrool () {
        var haveSomeOntabOpen = false;
        $(".ontab").each(function () {
            if ($(this).attr("data-minimize") === "0") {
                haveSomeOntabOpen = true;
            }
        });

        if (haveSomeOntabOpen) {
            $("html").scrollBlock();
        } else {
            $("html").scrollBlock(false);
        }
    }

    function getLastIndex ($tab) {
        var zindex = parseInt($tab.css("z-index"));
        $(".ontab").each(function () {
            if ($(this).attr("data-minimize") === "0" && $(this).attr("id") !== $tab.attr("id")) {
                zindex = (parseInt($(this).css("z-index")) >= zindex ? parseInt($(this).css("z-index")) + 1 : zindex);
            }
        });

        return zindex;
    }

    function reazusteMinimalize() {
        var i = 0;
        $(".ontab").each(function () {
            if ($(this).attr("data-minimize") === "1") {
                $(this).css("left", i * parseInt($(this).css("min-width")));
                i++;
            }
        });
    }

    function getInt (E, k) {
        return parseInt(E.css(k)) || false;
    }

$("#btnt").on("click", function () {
    $(document).panel();
});